*Herriges-Kling
clear
set matsize 1100

set more off

***************************************************
*series estimate
matrix CVEV=J(100,4,.)
global y=5
while $y<=100 {

matrix x=J(161,1,.)
matrix EV=J(161,1,.)
matrix CV=J(161,1,.)

qui cd "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data"
use fishing_data_herriges_kling.dta, clear
qui gen inc=income*1000

gen w4=(inc-pprivate)
gen w1=(inc-pbeach)
gen w3=(inc-pcharter)

qui save temp, replace
gen w1sq=w1*w1
gen w1cb=w1sq*w1

*nl (dprivate = -exp({b1})*w3-exp({b2})*w4+{b3}*qprivate+{b4}*qbeach+{b5}*qpier+{b6}*qcharter+{b7}*s1+{b8}*s2+{b9}*s3+{b0})

gen d=1-((dbeach==0)*(dpier==0))
qui probit d w1 w1sq w1cb w3 w4 qbeach
global p11=40
global p30=60
global p40=12

global a=-100
global k=1
while $a<0 {
matrix x[$a+101,1]=$a

global w1=(100*$y-$p11)

global w1sq=$w1*$w1
global w1cb=$w1*$w1*$w1
global w3=($y*100-$a-$p30)
global w4=($y*100-$a-$p40)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4) atmeans

matrix EV[$k,1]=r(b)

global w1=($y*100-$p11+$a)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($y*100-$p30)
global w4=($y*100-$p40)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4) atmeans

matrix CV[$k,1]=r(b)

global k=$k+1
global a=$a+1
}


qui probit dprivate  w1 w1sq w1cb w3 w4 qbeach qprivate qcharter
global a=0
while $a<=60 {
matrix x[$a+61,1]=$a
global w1=($y*100-$p11)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($y*100-$p30)
global w4=($y*100-$p40-$a)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4) atmeans


matrix EV[$k,1]=1-r(b)

global w1=($y*100+$a-$p11)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($y*100+$a-$p30)
global w4=($y*100-$p40)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4) atmeans

matrix CV[$k,1]=1-r(b)
global k=$k+1
global a=$a+1
}

svmat x
svmat EV
svmat CV

gen e=(1-EV1)*(x1>=0)-EV1*(x1<0)
gen c=(1-CV1)*(x1>=0)-CV1*(x1<0)

matrix CVEV[$y/5,1]=$y*100

*qui integ e x1
*matrix CVEV[$y/5,2]=$S_2

qui integ c x1 if x1<0
global aa=$S_2
qui integ c x1 if x1>0
global bb=$S_2
matrix CVEV[$y/5,3]=$aa+$bb


global y=$y+5
}

********************************
*Log sum using multinomial logit

clear
qui cd "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data"
use fishing_data_herriges_kling.dta, clear

constraint 1 [1]price=[3]price
constraint 2 [1]price=[4]price

qui mlogit mode price crate income, constraint(1 2) base(2)
matrix b=e(b)
global alfa=abs(b[1,1])

matrix cvmnl=J(20,2,.)
global s=1
while $s<=20 {
macro lis s
preserve
replace price=140 if mode==1
replace price =140 if mode==2
replace price=12 if mode==3
replace price =60 if mode==4
replace income=$s*0.5
margins, atmeans predict(outcome(1))
matrix t1=r(b)
global t1=t1[1,1]
restore
replace price=40 if mode==1
replace price =40 if mode==2
replace price=72 if mode==3
replace price =60 if mode==4
replace income=$s*0.5
margins, atmeans predict(outcome(1))
matrix t1=r(b)
global t2=t1[1,1]


matrix cvmnl[$s,2]=ln(($t2/$t1))/$alfa
matrix cvmnl[$s,1]=1000*$s
matrix CVEV[$s,4]=ln(($t2/$t1))/$alfa

global s=$s+1
}


svmat CVEV
drop income
ren CVEV1 income
ren CVEV2 EV
ren CVEV3 Cubic
ren CVEV4 LogSum
twoway (line Cubic LogSum income, sort lpattern(solid dash)), xtitle(Income) title("Figure 1: Average CV for Multiple Price Change")  saving(g1.gph, replace)
twoway (line Cubic income, sort lpattern(solid)), ytitle(Average Welfare Change) xtitle(Income) title(Average CV for Multiple Price Change) saving(g2.gph, replace)


*****************************************

*Elimination of private option
clear
set more off
global p1=75
global p3=60
global p4=33


matrix CVEV=J(100,7,.)
global y=5
while $y<=100 {
macro lis y
matrix x=J(600,1,.)
matrix EV=J(600,1,.)
matrix CV=J(600,1,.)
clear
qui cd "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data"
use fishing_data_herriges_kling.dta, clear
qui gen inc=income*1000

gen w4=(inc-pprivate)
gen w1=(inc-pbeach)
gen w3=(inc-pcharter)

qui save temp, replace
gen w1sq=w1*w1
gen w1cb=w1sq*w1

qui logit dprivate  w1 w1sq w1cb w3 w4 qbeach qprivate qcharter
global k=1
global a=1
while $a<=600 {
matrix x[$a,1]=$a
global w1=($y*100-$p3)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($y*100-$p1)
global w4=($y*100-$p4-$a)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4) atmeans


matrix EV[$k,1]=1-r(b)

global w1=($y*100+$a-$p3)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($y*100+$a-$p1)
global w4=($y*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4) atmeans

matrix CV[$k,1]=1-r(b)
global k=$k+1
global a=$a+1
}
svmat x
svmat EV
svmat CV

qui gen e=(1-EV1)*(x1>=0)-EV1*(x1<0)
qui gen c=(1-CV1)*(x1>=0)-CV1*(x1<0)

matrix CVEV[$y/5,1]=$y*100

*qui integ e x1
*matrix CVEV[$y/5,2]=$S_2


qui integ c x1 if x1>0
global bb=$S_2
matrix CVEV[$y/5,3]=$bb



global y=$y+5
}



*Elimination of private option using mn logit

clear
qui cd "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data"
use fishing_data_herriges_kling.dta, clear

constraint 1 [1]price=[3]price
constraint 2 [1]price=[4]price

qui mlogit mode price crate income, constraint(1 2) base(2)
matrix b=e(b)
global alfa=abs(b[1,1])

matrix cvmnl=J(20,2,.)
global s=1
while $s<=20 {
macro lis s
preserve
replace price=75 if mode==1
replace price =75 if mode==2
replace price=33 if mode==3
replace price =60 if mode==4
replace income=$s*0.5
margins, atmeans predict(outcome(3))
matrix t1=r(b)
global t1=t1[1,1]
restore
replace price=75 if mode==1
replace price =75 if mode==2
replace price=700 if mode==3
replace price =60 if mode==4
replace income=$s*0.5
margins, atmeans predict(outcome(3))
matrix t1=r(b)
global t2=t1[1,1]


*matrix cvmnl[$s,2]=ln(($t1/$t2))/$alfa
*matrix cvmnl[$s,1]=1000*$s
matrix CVEV[$s,4]=ln(($t1/$t2))/$alfa
matrix CVEV[$s,1]=1000*$s*0.5

global s=$s+1
}



*****************************************



*Elimination of charter option
global p1=75
global p3=60
global p4=33

global y=5
while $y<=100 {
macro lis y
matrix x=J(600,1,.)
matrix EV=J(600,1,.)
matrix CV=J(600,1,.)

clear
qui cd "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data"
use fishing_data_herriges_kling.dta, clear
qui gen inc=income*1000

gen w4=(inc-pprivate)
gen w1=(inc-pcharter)
gen w3=(inc-pbeach)

qui save temp, replace
gen w1sq=w1*w1
gen w1cb=w1sq*w1

qui logit dcharter  w1 w1sq w1cb w3 w4 qbeach qprivate qcharter
global k=1
global a=1
while $a<=600 {
matrix x[$a,1]=$a
global w1=($y*100-$p3-$a)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($y*100-$p1)
global w4=($y*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4) atmeans


matrix EV[$k,1]=1-r(b)

global w1=($y*100-$p3)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($y*100+$a-$p1)
global w4=($y*100+$a-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4) atmeans

matrix CV[$k,1]=1-r(b)
global k=$k+1
global a=$a+1
}
svmat x
svmat EV
svmat CV

qui gen e=(1-EV1)*(x1>=0)-EV1*(x1<0)
qui gen c=(1-CV1)*(x1>=0)-CV1*(x1<0)

*qui integ e x1
*matrix CVEV[$y/5,5]=$S_2


qui integ c x1 if x1>0
global bb=$S_2
matrix CVEV[$y/5,6]=$bb


global y=$y+5
}


*Elimination of charter option using mn logit
clear
qui cd "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data"
use fishing_data_herriges_kling.dta, clear

constraint 1 [1]price=[3]price
constraint 2 [1]price=[4]price

qui mlogit mode price crate income, constraint(1 2) base(2)
matrix b=e(b)
global alfa=abs(b[1,1])

matrix cvmnl=J(20,2,.)
global s=1
while $s<=20 {
macro lis s
preserve
replace price=75 if mode==1
replace price =75 if mode==2
replace price=33 if mode==3
replace price =60 if mode==4
replace income=$s*0.5
margins, atmeans predict(outcome(4))
matrix t1=r(b)
global t1=t1[1,1]
restore
replace price=75 if mode==1
replace price =75 if mode==2
replace price=33 if mode==3
replace price =700 if mode==4
replace income=$s*0.5
*matrix CVEV[$s,1]=$s*0.5*1000

margins, atmeans predict(outcome(4))
matrix t1=r(b)
global t2=t1[1,1]


*matrix cvmnl[$s,2]=ln(($t2/$t1))/$alfa
*matrix cvmnl[$s,1]=1000*$s
matrix CVEV[$s,7]=ln(($t2/$t1))/$alfa

global s=$s+1
}

svmat CVEV
drop income
ren CVEV1 income
ren CVEV2 EV_private
ren CVEV3 CV_private
ren CVEV4 LogSum_private
ren CVEV6 CV_charter
ren CVEV7 LogSum_charter


twoway (line CV_private LogSum_private income, sort lpattern(solid dash dotdash longdash)), xtitle(Income) title(Avg CV: Eliminate Pvt) saving(g2.gph, replace)
twoway (line CV_charter LogSum_charter income, sort lpattern(solid dash dotdash longdash)), xtitle(Income) title(Avg CV: Eliminate Charter) saving(g3.gph, replace)
twoway (line CV_charter CV_private income, sort lpattern(solid dash dotdash longdash)), xtitle(Income) ti("Fig. 3: Eliminate Charter vs Pvt") saving(g4.gph, replace)
graph combine "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data\g2.gph" "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data\g3.gph", ti("Figure 2: Elimination of Option: LogSum vs Cubic")
********************************************
*Quality Change


********************************************************

*Quality change bounds
clear
set matsize 10000
set more off

matrix drop _all
matrix a=J(101,2,.)
matrix CVCV=J(20,5,.)
matrix res=J(100,2,.)
matrix lb=J(500,2,.)
matrix ub=J(500,2,.)

qui cd "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data"
use fishing_data_herriges_kling.dta, clear
qui gen inc=income*1000

gen w4=(inc-pcharter)
gen w1=(inc-pbeach)
gen w3=(inc-pprivate)
gen w1sq=w1*w1
gen w1cb=w1sq*w1

qui logit dbeach  w1 w1sq w1cb w3 w4 qbeach qprivate qcharter, iter(25)

global y=5
while $y<=100 {

macro lis y
global a=-500
global p1=75
global p3=55
global p4=84
global w1=($y*100-$p1)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1

global w3=($y*100-$p3)
global w4=($y*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4 qbeach=0.06) atmeans
matrix t=r(b)
global t=t[1,1]

while $a<=0 {

global ypr=5

while $ypr<=$y {
global w1=($y*100-$p1+$a)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($ypr*100-$p3)
global w4=($ypr*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4 qbeach=0.53) atmeans
matrix r=r(b)
global b=r[1,1]

global w1=($y*100-$p1)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($ypr*100-$p3)
global w4=($ypr*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4 qbeach=0.06) atmeans
matrix r=r(b)
global s=1-r[1,1]

global s=$b+$s

matrix res[$ypr/5,1]=$ypr/5
matrix res[$ypr/5,2]=$s
global ypr=$ypr+5
}

svmat res
qui gsort -res2
global t=res2[1]
qui drop res1 res2
global w1=($y*100-$p1+$a)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($y*100-$p3)
global w4=($y*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4 qbeach=0.53) atmeans
matrix r=r(b)
global s=$s-1-1+r[1,1]
matrix lb[($a+500)/5+1,1]=$a
matrix lb[($a+500)/5+1,2]=max($s,0)

*UB
global ypr=$y
while $ypr<=100 {
global w1=($y*100-$p1+$a)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($ypr*100-$p3)
global w4=($ypr*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4 qbeach=0.53) atmeans
matrix r=r(b)
global s=r[1,1]

global w1=($y*100-$p1)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($ypr*100-$p3)
global w4=($ypr*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4 qbeach=0.06) atmeans
matrix r=r(b)
global s=1-r[1,1]

global w1=($y*100-$p1+$a)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($ypr*100-$p3)
global w4=($ypr*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4 qbeach=0.53) atmeans
matrix r=r(b)
global s=$s+r[1,1]
matrix res[$ypr/5,1]=$ypr/5
matrix res[$ypr/5,2]=$s
global ypr=$ypr+5
}
svmat res
qui gsort -res2
global t=res2[1]
qui drop res1 res2
global w1=($y*100-$p1+$a)
global w1sq=$w1*$w1
global w1cb=$w1sq*$w1
global w3=($y*100-$p3)
global w4=($y*100-$p4)
qui margins, at(w1=$w1 w1sq=$w1sq w1cb=$w1cb w3=$w3 w4=$w4 qbeach=0.53) atmeans
matrix r=r(b)
global b=r[1,1]
global s=min($b,$t)
matrix ub[($a+500)/5+1,2]=$s
matrix ub[($a+500)/5+1,1]=$a

global a=$a+5
}

matrix CVCV[$y/5,1]=$y*100
svmat lb

integ lb2 lb1 if lb1~=0 & lb1~=.
matrix CVCV[$y/5,2]=$S_2

svmat ub
integ ub2 ub1 if ub1~=0 & ub1~=.

matrix CVCV[$y/5,3]=$S_2

global y=$y+5
qui drop ub* lb*
}


*Increase in Catch-rate using mn logit
clear
qui cd "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data"
use fishing_data_herriges_kling.dta, clear

constraint 1 [1]price=[3]price
constraint 2 [1]price=[4]price

qui mlogit mode price crate income, constraint(1 2) base(2) iter(25)
matrix b=e(b)
global alfa=abs(b[1,1])

matrix cvmnl=J(20,2,.)
global s=1
while $s<=20 {
macro lis s
preserve
replace price=75 if mode==1
replace price =75 if mode==2
replace price=55 if mode==3
replace price =84 if mode==4
replace crate=0.06 if mode==1
replace income=$s*0.5
margins, atmeans predict(outcome(1))
matrix t1=r(b)
global t1=t1[1,1]
restore
replace price=75 if mode==1
replace price =75 if mode==2
replace price=55 if mode==3
replace price =84 if mode==4
replace income=$s*0.5
replace crate=0.53 if mode==1

*matrix CVEV[$s,1]=$s*0.5*1000

margins, atmeans predict(outcome(1))
matrix t1=r(b)
global t2=t1[1,1]


matrix CVCV[$s,5]=-ln(($t2/$t1))/$alfa

global s=$s+1
}

*LogSum without Income
*Increase in Catch-rate using mn logit
clear
qui cd "C:\Users\Debopam\OneDrive - University Of Cambridge\Welfare\Fishing_Data"
use fishing_data_herriges_kling.dta, clear

constraint 1 [1]price=[3]price
constraint 2 [1]price=[4]price

qui mlogit mode price crate, constraint(1 2) base(2) iter(25)
matrix b=e(b)
global alfa=abs(b[1,1])

matrix cvmnl=J(20,2,.)
global s=1
while $s<=20 {
macro lis s
preserve
replace price=75 if mode==1
replace price =75 if mode==2
replace price=55 if mode==3
replace price =84 if mode==4
replace crate=0.06 if mode==1
replace income=$s*0.5
margins, atmeans predict(outcome(1))
matrix t1=r(b)
global t1=t1[1,1]
restore
replace price=75 if mode==1
replace price =75 if mode==2
replace price=55 if mode==3
replace price =84 if mode==4
replace income=$s*0.5
replace crate=0.53 if mode==1


margins, atmeans predict(outcome(1))
matrix t1=r(b)
global t2=t1[1,1]


matrix CVCV[$s,4]=-ln(($t2/$t1))/$alfa

global s=$s+1
}



svmat CVCV
ren CVCV1 Income
ren CVCV2 LB
ren CVCV3 UB
ren CVCV4 LogSum_no_Income
ren CVCV5 Logsum
keep LB UB Logsum LogSum_no_Income Income
save quality_result, replace

twoway (line LB UB LogSum_no_Income Logsum Income, sort lpattern(dash dash solid dash_dot)), xtitle(Income) ti("Fig. 4: Avg Welfare Loss from Reduced Catch Rate") saving(g5.gph, replace)












